var backgroundSearches;

function showPrefs()
{
	var front = document.getElementById("front");
	var back_w = document.getElementById("back");
	if (window.widget)
		widget.prepareForTransition("ToBack");
	front.style.display="none";
	back_w.style.display="block";

	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}


function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget)
		widget.prepareForTransition("ToFront");
	back.style.display="none";
	front.style.display="block";
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
	savePrefs();
}


function savePrefs(){
	var daysBox  = document.getElementById("prefDaysBox");
	var specDays = daysBox.value;
		
	if(specDays != "" && isNumeric(specDays)){
		tooOld = specDays;
	}else{
		tooOld = 90;
		daysBox.value = 90;
	}
	widget.setPreferenceForKey(tooOld,"age");
	
	backgroundSearches = document.getElementById("prefBackgroundSearchBox").checked;
	widget.setPreferenceForKey(backgroundSearches, "bgs");

	saveExcludedList();
	saveCDInfo();
}

function loadPrefs(){
	//get age preference
	var age = widget.preferenceForKey("age");
	if(age && age.length > 0){
		tooOld = age;
	}else{
		tooOld = 90;
	}

	document.getElementById("prefDaysBox").value = tooOld;
	//get 'allow background searches'
	var bgs = widget.preferenceForKey("bgs");
	if(bgs && bgs == 1){
		backgroundSearches = true;
		document.getElementById("prefBackgroundSearchBox").checked = 1;
	}else{
		backgroundSearches = false;
		document.getElementById("prefBackgroundSearchBox").checked = 0;
	}
	
	//get excluded artists
	var excluded = widget.preferenceForKey("excluded");
	if(excluded && excluded.length > 0){
		var excludedJSON = eval(excluded);
		excluded_artists = excludedJSON.excluded;	
	}else{
		excluded_artists = new Array();
	}
	
	//get artists preference
	var artists = widget.preferenceForKey("artists");
	if(artists && artists.length > 0){
		all_artists = eval(artists).artists;
		constructArtistList();
	}else{
		setStatus("Loading artists (this may take a few moments)");
		//start this on a new thread
		setTimeout("refreshArtists();", 0);
		
	}
	
	//get cd list
	var cdJSON = widget.preferenceForKey("cds");
	if(cdJSON && cdJSON.length > 0){
		var cds_object = eval(cdJSON);
		cds = cds_object.cds;
		cdsAdded = 0;
		constructResults(0, cds.length);
	}else{
		initSearch();
	}
}

function saveCDInfo(){
	if(cds == null || cds.length == 0){
		widget.setPreferenceForKey(null, "cds");
	}else{
		var cdsJSON = '{"cds" : [ {"artist":"' + cds[0].artist + '","title":"' + cds[0].title +'","date":"' + cds[0].date + '","url":"' + cds[0].url + '"}';	
		for(var i = 1; i < cds.length; i++){
			var cd = cds[i];
			cdsJSON += ', {"artist":"' + cd.artist + '","title":"' + cd.title +'","date":"' + cd.date + '","url":"' + cd.url + '"}';
		}
		cdsJSON += '] }';
		widget.setPreferenceForKey(cdsJSON, "cds");
	}
}

function saveExcludedList(){
	if(excluded_artists.length == 0){
		widget.setPreferenceForKey(null, "excluded");
	}else{
		var exJSON = '{"excluded" : [ "' + excluded_artists[0] + '"';
		for(var i = 1; i < excluded_artists.length; i++){
			exJSON += ', "' + excluded_artists[i] + '"';
		}
		exJSON += '] }';
		widget.setPreferenceForKey(exJSON, "excluded");
	}
}

function saveArtists(){
	if(all_artists == null){
		widget.setPreferenceForKey(null, "artists");
	}else{
		var aJSON = '{"artists" : [ "' + excluded_artists[0] + '"';
		for(var i = 1; i < all_artists.length; i++){
			aJSON += ', "' + excluded_artists[i] + '"';
		}
		aJSON += '] }';
		widget.setPreferenceForKey(aJSON, "artists");
	}
}